@echo off
VERIFY OTHER 2>nul
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
IF ERRORLEVEL 1 ECHO Unable to enable extensions

IF DEFINED JAVA_HOME (
    SET JAVA_HOME=%JAVA_HOME%\bin\
    ECHO JAVA_HOME is defined as %JAVA_HOME%
    GOTO End
) ELSE (
    ECHO JAVA_HOME does not exist, searching in PATH
    GOTO SearchPath
)


:SearchPath
call :s_which java.exe
IF DEFINED JAVA_HOME (
    @echo java.exe found at %JAVA_HOME%
    GOTO End
) ELSE (
    @echo java.exe not found, searching randomly on C:, please wait
    GOTO SearchDrive
)


:SearchDrive
where /R C:\ java.exe > %temp%\mycmd.txt
SET /P mycmd=<%temp%\mycmd.txt
SET JAVA_HOME=%mycmd%e.
GOTO End


:End
SET JAVA_HOME=!JAVA_HOME:"=!
@echo Using: !JAVA_HOME!

"!JAVA_HOME!\java" -version
"!JAVA_HOME!\java" -Xms256M -Xmx758M -jar Sulphur_Nimbus.jar

pause
goto :eof

:s_which
    set JAVA_HOME=%~$PATH:1
    IF DEFINED JAVA_HOME (
        SET JAVA_HOME=%JAVA_HOME:"=%
        FOR %%A in ("%JAVA_HOME%") do (
            SET JAVA_HOME=%%~dpA
        )
    )
    goto :eof

ENDLOCAL